import { Compilation } from ".";
import { StatsOptions, StatsValue } from "./config";
import type { StatsCompilation } from "./stats/statsFactoryUtils";
export type { StatsAsset, StatsChunk, StatsCompilation, StatsError, StatsModule, StatsWarnings } from "./stats/statsFactoryUtils";
export declare class Stats {
    #private;
    compilation: Compilation;
    constructor(compilation: Compilation);
    get hash(): string | null;
    hasErrors(): boolean;
    hasWarnings(): boolean;
    toJson(opts?: StatsValue, forToString?: boolean): StatsCompilation;
    toString(opts?: StatsValue): string;
}
export declare function normalizeStatsPreset(options?: StatsValue): StatsOptions;
