import { Callback } from "tapable";
import { Compiler } from "./Compiler";
import { MultiCompiler, MultiRspackOptions } from "./MultiCompiler";
import MultiStats from "./MultiStats";
import { Stats } from "./Stats";
import { RspackOptions } from "./config";
declare function createMultiCompiler(options: MultiRspackOptions): MultiCompiler;
declare function createCompiler(userOptions: RspackOptions): Compiler;
declare function rspack(options: MultiRspackOptions): MultiCompiler;
declare function rspack(options: RspackOptions): Compiler;
declare function rspack(options: MultiRspackOptions | RspackOptions): MultiCompiler | Compiler;
declare function rspack(options: MultiRspackOptions, callback?: Callback<Error, MultiStats>): null | MultiCompiler;
declare function rspack(options: RspackOptions, callback?: Callback<Error, Stats>): null | Compiler;
declare function rspack(options: MultiRspackOptions | RspackOptions, callback?: Callback<Error, MultiStats | Stats>): null | MultiCompiler | Compiler;
export { createCompiler, createMultiCompiler, MultiStats, rspack, Stats };
export default rspack;
